

--[[


	$project:		Afterlife Crowd Control
	$copyright:		Michael Boyle (www.softrix.co.uk).
							
	$credits:		Created by Michael Boyle.

					This addon uses a modified version of the GTB
					bar library by Shadowed. For the purpose of 
					these credits the original bar library can be
					downloaded from:
							
					http://www.wowinterface.com/downloads/info10204-GTB-1.0.html
					
					Special thanks to Arbixal, pakal1 on curse.com for their development
					support while i was absent from the game  =)
					
					If you need to contact me send a email to michael.boyle@softrix.co.uk
		
]]--


-- afterlife version (for introduction text on load)
AFTERLIFE_VERSION = "40300-R3";		-- released 8/12/2011

-- Afterlifes saved settings structure.
Afterlife_SavedSettings = {	 
	true,														-- addon alive?
	true,														-- anchors shown?
	-- font is for future use.
	10, 300, "UP", 15, 250, 4, 20, 1, 9,						-- x, y, dir, height, width, texture, max bars, font, font size		[CC]
	10, 390, "UP", 15, 250, 4, 20, 1, 9,						-- x, y, dir, height, width, texture, max bars, font, font size		[DIMINISH]
	10, 420, "UP", 15, 250, 4, 20, 1, 9,						-- x, y, dir, height, width, texture, max bars, font, font size		-- reserved --
	true,														-- announce applied cc	[30]
	true, false, true, true, true,								-- announce breaks, announce party apply?, sound?, flash?, popup?	[31-35]
	true, true, false,											-- announce immune?, announce resist?, announce evade?	[36-38]
	true, false,												-- sound on spell miss?, flash ui on spell miss?	[39-40]
	true,														-- announce my timeleft to party?		[41]
	false,														-- announce others timeleft to party?
	true,														-- play sound on 5sec left with my cc.
	true,														-- show 3d model
	true, "Male", false,										-- PvP sounds?, Sex, On NPC?
	true,														-- Clear timers on my death
	true,														-- sticky 3d target?
	true,														-- Show my interrupts?					[50]
	false,														-- diminish returns.
	true,														-- disable all announces in battlegrounds.
	true,														-- auto reputation bar
	true														-- enable timer bars.					[54]
};

AFTERLIFE_FULLYLOADED = false; 

-- used to store names of those players I dont want to see
-- break announcements, i.e. my regular tank who should be
-- breaking the mobs anyway  =)
Afterlife_IgnoredPlyrBreaks = {}; 

-- list of spells supported
Afterlife_SpellsSupported = { 

	-- spellid, duration, dr?, melee breakable (if i smack it with a mace etc)
	
	--priest
	{9484, 50, true, true}, 	-- Shackle Undead
	{605, 30, true, false}, 	-- Mind Control	
	-- warlock
	{6358, 30, true, true}, 	-- Seduction (Warlock Succubus)
	{1098, 300, true, true},  	-- Enslave Demon
	{710, 30, true, false}, 	-- Banish
	{5782, 20, true, false}, 	-- Fear	
	-- mage (checked)
	{118, 50, true, true}, 		-- Polymorph
	
	{28271, 50, true, true}, 	-- Polymorph: Turtle
	{28272, 50, true, true}, 	-- Polymorph: Pig
	{61305, 50, true, true}, 	-- Polymorph: Black Cat
	{61025, 50, true, true}, 	-- Polymorph: Serpent
	{61721, 50, true, true}, 	-- Polymorph: Rabbit
	{61780, 50, true, true}, 	-- Polymorph: Turkey
	-- druid (checked)
	{2637, 40, true, true}, 	-- Hibernate 
	{339, 30, true, false}, 	-- Entangling Roots
	{33786, 6, true, false}, 	-- Cyclone	
	-- hunter (checked)
	{3355, 60, true, true}, 	-- Freezing Trap
	{19386, 30, true, true},	-- Wyvern Sting
	{1513, 20, true, true},		-- Scare Beast	
	-- rogue (checked)
	{6770, 60, true, true}, 	-- Sap
	{2094, 10, false, true},	-- Blind	
	-- paladin (checked)
	{20066, 60, true, true},	-- Repentance
	{10326, 20, true, true},	-- Turn Evil
	{853, 6, true, true},		-- Hammer of Justice	
	-- shaman (checked)
	{51514, 60, true, false},	-- Hex
	{76780, 50, true, true},	-- Bind Elemental
}; 

-- textures for the bars, more will be added soon - Mik 5/12/2011
Afterlife_Textures = { 

	"Interface\\Addons\\Afterlife\\Graphics\\bantobar.tga", 
	"Interface\\Addons\\Afterlife\\Graphics\\charcoal.tga", 
	"Interface\\Addons\\Afterlife\\Graphics\\otravi.tga", 
	"Interface\\Addons\\Afterlife\\Graphics\\perl.tga",
	"Interface\\Addons\\Afterlife\\Graphics\\smooth.tga", 
	"Interface\\Addons\\Afterlife\\Graphics\\smudge.tga", 
	"Interface\\Addons\\Afterlife\\Graphics\\striped.tga", 

};

-- path to the various sounds used by the addon.
Afterlife_ImmuneSND = "Interface\\Addons\\Afterlife\\Sounds\\immune.mp3"; 
Afterlife_BreakSND = "Interface\\Addons\\Afterlife\\Sounds\\ccbreak.mp3"; 
Afterlife_MissSND = "Interface\\Addons\\Afterlife\\Sounds\\spellmiss.mp3"; 
Afterlife_10secSND = "Interface\\Addons\\Afterlife\\Sounds\\10secwarn.mp3"; 
Afterlife_TDeadSND = "Interface\\Addons\\Afterlife\\Sounds\\targetdies.mp3"; 
Afterlife_GreenFlashGFX = "Interface\\Addons\\Afterlife\\Graphics\\green_flashgfx.tga"; 
Afterlife_RedFlashGFX = "Interface\\Addons\\Afterlife\\Graphics\\red_flashgfx.tga"; 
Afterlife_RedDR = "Interface\\Addons\\Afterlife\\Graphics\\dr_red.tga"; 
Afterlife_GreenDR = "Interface\\Addons\\Afterlife\\Graphics\\dr_green.tga"; 
Afterlife_NEPlayer = "Interface\\Addons\\Afterlife\\Graphics\\neplayer.tga"; 

-- unreal/quake sounds for the pvp side of fun  =)
Afterlife_QuakeSND = {
	-- Male
	"Interface\\AddOns\\Afterlife\\Sounds\\UnrealPvP\\Male\\dominating.mp3",
	"Interface\\AddOns\\Afterlife\\Sounds\\UnrealPvP\\Male\\firstblood.mp3",
	"Interface\\AddOns\\Afterlife\\Sounds\\UnrealPvP\\Male\\godlike.mp3",
	"Interface\\AddOns\\Afterlife\\Sounds\\UnrealPvP\\Male\\killingspree.mp3",
	"Interface\\AddOns\\Afterlife\\Sounds\\UnrealPvP\\Male\\monsterkill.mp3",
	"Interface\\AddOns\\Afterlife\\Sounds\\UnrealPvP\\Male\\unstoppable.mp3",
	-- Female
	"Interface\\AddOns\\Afterlife\\Sounds\\UnrealPvP\\Female\\dominating.mp3",
	"Interface\\AddOns\\Afterlife\\Sounds\\UnrealPvP\\Female\\firstblood.mp3",
	"Interface\\AddOns\\Afterlife\\Sounds\\UnrealPvP\\Female\\godlike.mp3",
	"Interface\\AddOns\\Afterlife\\Sounds\\UnrealPvP\\Female\\killingspree.mp3",
	"Interface\\AddOns\\Afterlife\\Sounds\\UnrealPvP\\Female\\monsterkill.mp3",
	"Interface\\AddOns\\Afterlife\\Sounds\\UnrealPvP\\Female\\unstoppable.mp3"
};

Afterlife_MonitoredMobs = {};	-- stores details of monitored mobs around me. 
Afterlife_DRTracking = {};		-- stores any diminish returns.

-- Raid Marks 
Afterlife_RaidMarks = {"{rt1}","{rt2}","{rt3}","{rt4}","{rt5}", "{rt6}","{rt7}","{rt8}",""};

Afterlife_ChatDestination = 0; 
Afterlife_IsPlayerInArena = false; 
Afterlife_PlayerInPvP = false; 
Afterlife_TargetGUID = 0;
Afterlife_UpdateInterval = .01; 
Afterlife_ScaleInterval = .1; 
Afterlife_GraphicPause = 150; 
Afterlife_MovingPopup = false; 
Afterlife_CastingGUID = 0; 
Afterlife_CastingRaidIcon = 0;

-- 
--	Initialise the addon such as the groups.
--
function Afterlife_Initialise()
	AfterlifeLib = LibStub:GetLibrary("Afterlife-1.0");
	Afterlife_SetLocalisation();
	AfterlifePrimaryGroup = AfterlifeLib:RegisterGroup(PRIMARY_GROUP_TITLE, Afterlife_Textures[Afterlife_SavedSettings[8]]);
	AfterlifePrimaryGroup:RegisterOnMove("Afterlife_PrimaryOnBarMove");
	AfterlifePrimaryGroup:SetInvert(false);
	AfterlifePrimaryGroup:SetScale(1.0);
	AfterlifePrimaryGroup:SetMaxBars(Afterlife_SavedSettings[9]);
	AfterlifePrimaryGroup:SetWidth(Afterlife_SavedSettings[7]);
	AfterlifePrimaryGroup:SetHeight(Afterlife_SavedSettings[6]);
	AfterlifePrimaryGroup:SetDisplayGroup("");
	AfterlifePrimaryGroup:SetAnchorVisible(Afterlife_SavedSettings[2]);
	AfterlifePrimaryGroup:SetBarGrowth(Afterlife_SavedSettings[5]);
	AfterlifePrimaryGroup:SetGroupFontSize(Afterlife_SavedSettings[11]);
	AfterlifePrimaryGroup:SetPoint("TOPLEFT", UIParent, "BOTTOMLEFT", Afterlife_SavedSettings[3], Afterlife_SavedSettings[4])
	AfterlifeDiminishGroup = AfterlifeLib:RegisterGroup(DIMINSH_RETURNS_TITLE, Afterlife_Textures[Afterlife_SavedSettings[17]]);
	AfterlifeDiminishGroup:RegisterOnMove("Afterlife_DiminishOnBarMove");
	AfterlifeDiminishGroup:SetInvert(false);
	AfterlifeDiminishGroup:SetScale(1.0);
	AfterlifeDiminishGroup:SetMaxBars(Afterlife_SavedSettings[18]);
	AfterlifeDiminishGroup:SetWidth(Afterlife_SavedSettings[16]);
	AfterlifeDiminishGroup:SetHeight(Afterlife_SavedSettings[15]);
	AfterlifeDiminishGroup:SetDisplayGroup("");
	if(Afterlife_SavedSettings[51])	then
		AfterlifeDiminishGroup:SetAnchorVisible(Afterlife_SavedSettings[2]);
	else
		AfterlifeDiminishGroup:SetAnchorVisible(false);
	end;
	AfterlifeDiminishGroup:SetBarGrowth(Afterlife_SavedSettings[14]);
	AfterlifeDiminishGroup:SetGroupFontSize(Afterlife_SavedSettings[20]);
	AfterlifeDiminishGroup:SetPoint("TOPLEFT", UIParent, "BOTTOMLEFT", Afterlife_SavedSettings[12], Afterlife_SavedSettings[13])
	AFTERLIFE_FULLYLOADED = true;
end;
function Afterlife_PrimaryOnBarMove(parent, x, y)
	Afterlife_SavedSettings[3] = x 
	Afterlife_SavedSettings[4] = y 
end;
function Afterlife_DiminishOnBarMove(parent, x, y)
	Afterlife_SavedSettings[12] = x Afterlife_SavedSettings[13] = y
end;

--
--	Addon OnLoad event, register our additional events needed by the addon.
--
function Afterlife_OnLoad() 
	Afterlife:RegisterEvent("ADDON_LOADED"); 
	Afterlife:RegisterEvent("PLAYER_DEAD");
	Afterlife:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
	Afterlife:RegisterEvent("CHAT_MSG_COMBAT_FACTION_CHANGE");
	Afterlife:RegisterEvent("PLAYER_ENTERING_WORLD");
	Afterlife:RegisterEvent("PLAYER_TARGET_CHANGED");
	SlashCmdList["AFTERLIFE"] = Afterlife_Commandline;
	SLASH_AFTERLIFE1="/afterlife"; 
end;

--
--	OnUpdate Event
--
function Afterlife_OnUpdate() 
	if(Afterlife_SavedSettings[41]) then 
		Afterlife_AnnounceCCExpire(); 
	end;
end;

--
--	Commpand Line Parser
--
function Afterlife_Commandline(args) 
	local lowerargs = strlower(args); 
	if(lowerargs == "ignore") then 
		local targetsName = UnitName("target");
		if(targetsName) then 
			Afterlife_AddIgnoredPlayer(targetsName);
		else 
			DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife : |cffffffffNo target is selected to be ignored.");
		end;
	elseif(lowerargs == "unignore") then 
		local targetsName = UnitName("target");
		if(targetsName) then 
			Afterlife_RemoveIgnoredPlayer(targetsName);
		else 
			DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife : |cffffffffNo target is selected to be removed from ignore list.");
		end;
	elseif(lowerargs == "showignored") then 
		Afterlife_ShowAllIgnoredPlayers();
	else 
		Afterlife_InitOptions();
		Afterlife_Options:Show();
	end;  
end;

--
--	Function to determine where I am in the world and where I need to announce my messages.
--
function Afterlife_SetPartyStatus() 
	local playerInstance, instanceType = IsInInstance();
	if(instanceType == "arena" or instanceType == "pvp") then 
		Afterlife_PlayerInPvP = true;
		Afterlife_IsPlayerInArena = true;
		if(not(Afterlife_SavedSettings[52])) then 
			Afterlife_ChatDestination = "BATTLEGROUND";
		else 
			Afterlife_ChatDestination = 0;
		end; 
	elseif (GetPartyMember(1)) then 
		Afterlife_PlayerInPvP = false;
		Afterlife_IsPlayerInArena = false;
		Afterlife_ChatDestination = "PARTY";  
		if (GetNumRaidMembers() > 0) then  
			Afterlife_ChatDestination = "RAID"; 
		end;
	else 
		Afterlife_PlayerInPvP = false;
		Afterlife_IsPlayerInArena = false;
		Afterlife_ChatDestination = 0;
	end;
end;

--
--	Where the magic takes place, the main event handler.
--
function Afterlife_EventHandler(event, ...)  

	-- has addon loaded, if so initialise it.
	if(event == "ADDON_LOADED") then 
		local addon = ...;
		if(addon == "Afterlife") then 
			Afterlife_Initialise();
			DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife Crowd Control (r"..AFTERLIFE_VERSION..") loaded! Type /afterlife for options.|cffffffff - Programmed by Michael Boyle (www.softrix.co.uk).  You can email me direct on michael.boyle@softrix.co.uk or use the Curse or Wowinterface pages.");
		end; 
	end; 
	
	-- have i died?
	if(event == "PLAYER_DEAD") then 
		if(Afterlife_SavedSettings[48]) then 
			Afterlife_ClearAllGUID();
		end;
	end; 
	
	-- have i entered the world?
	if(event == "PLAYER_ENTERING_WORLD") then 
		Afterlife_SetPartyStatus();
		Afterlife_ClearAllGUID();
	end; 
	
	-- have i changed my target?
	if(event == "PLAYER_TARGET_CHANGED") then 
		Afterlife_TargetGUID = UnitGUID("target");
		Afterlife_Set3dTarget(Afterlife_TargetGUID);
	end; 

	-- have I received some reputation with a faction?
	if(event == "CHAT_MSG_COMBAT_FACTION_CHANGE" and Afterlife_SavedSettings[1]) then 
		if(Afterlife_SavedSettings[53]) then 
			local chatMessage = ...;
			Afterlife_AutoChangeRepBar(chatMessage); 
		end;
	end; 
	
	-- have I received something connected with combat.
	if(event == "COMBAT_LOG_EVENT_UNFILTERED" and Afterlife_SavedSettings[1]) then  
		
		-- grab the returned event arguments.
		local arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9, arg10, arg11, arg12, arg13, arg14, arg15, arg16, arg17, arg18 = ...
		if(arg2 == "SPELL_CAST_START") then 
			if(arg4 == UnitGUID("player")) then 
				Afterlife_CastingGUID = UnitGUID("target");
				Afterlife_CastingRaidIcon = Afterlife_ProcessRaidIcon();
			end;	
		
		elseif(arg2 == "SPELL_INTERRUPT") then 
			if(Afterlife_SavedSettings[50]) then
				-- i want to let people know ive interrupted a spell.
				if(arg5 and arg13 and arg16) then	-- check i have what i need.
					if(arg4 == UnitGUID("player")) then					
						-- this was something i interrupted.
						Afterlife_SetPartyStatus();
						local msg = string.format(AFTERLIFE_SPELL_INTERRUPTED, arg16, arg5, arg13);
						if(not(Afterlife_ChatDestination==0)) then 
							SendChatMessage(msg, Afterlife_ChatDestination); 
						end;						
					end;
				end;
			end;
			
		elseif(arg2 == "SPELL_CAST_SUCCESS") then 
			if(arg4 == UnitGUID("player")) then 
				Afterlife_CastingGUID = UnitGUID("target");
				Afterlife_CastingRaidIcon = Afterlife_ProcessRaidIcon();
			end;
			
		elseif(arg2 == "SPELL_AURA_APPLIED") then 
			local duration, icon, isplayer, ishostile, dr, breakable = Afterlife_GetDuration(arg12, arg8, arg10);
			if(duration and arg9) then 
				-- was this my cast but not something that was cast on me by me (mind control etc)
				if(arg4 == UnitGUID("player") and not(arg8 == UnitGUID("player"))) then 
					local incSource = nil;
					-- determine if this mob is my target or focus.
					if(arg8 == UnitGUID("target")) then incSource = "Target"; elseif(arg8 == UnitGUID("focus")) then incSource = "Focus"; end; 
					duration = Afterlife_AddTrackedGUID(arg8, arg9, arg12, arg13, duration, GetTime(), ishostile, incSource, icon, Afterlife_CastingRaidIcon, arg12..arg8, arg5, arg10);
					if(Afterlife_SavedSettings[54]) then 
						AfterlifePrimaryGroup:RegisterBar(arg12..arg8, arg13.." ("..arg5..")", duration, duration, icon, nil); 
					end;
					Afterlife_Set3dTarget(Afterlife_TargetGUID);
					Afterlife_SetPartyStatus();
					local msg = string.format(AFTERLIFE_APPLIED_SPELL, arg13, Afterlife_CastingRaidIcon, arg9);
					if(not(Afterlife_ChatDestination==0) and Afterlife_SavedSettings[30]) then 
						SendChatMessage(msg, Afterlife_ChatDestination); 
					end;
				elseif(not(arg4 == UnitGUID("player")) and not(arg8 == UnitGUID("player"))) then 
					if(UnitPlayerOrPetInRaid(arg5) or UnitPlayerOrPetInParty(arg5)) then 
						duration = Afterlife_AddTrackedGUID(arg8, arg9, arg12, arg13, duration, GetTime(), ishostile, incSource, icon, nil, arg12..arg8, Afterlife_StripServer(arg5), arg10);
						if(Afterlife_SavedSettings[54]) then 
							AfterlifePrimaryGroup:RegisterBar(arg12..arg8, Afterlife_StripServer(arg5).." ("..arg13..")", duration, duration, icon, nil); 
						end;
						-- do i want to announce others in my party/raid
						if(Afterlife_SavedSettings[32]) then
							-- time for some spam in 25man  =)
							Afterlife_SetPartyStatus();
							local msg = string.format(AFTERLIFE_PARTY_APPLIED_SPELL, Afterlife_StripServer(arg5), arg13, Afterlife_CastingRaidIcon, arg9);
							if(not(Afterlife_ChatDestination==0)) then 
								SendChatMessage(msg, Afterlife_ChatDestination); 
							end;							
						end;
					end;
				end;
			end;
			
		elseif(arg2 == "SPELL_AURA_REFRESH") then 
			local duration, icon, isplayer, ishostile, dr, breakable = Afterlife_GetDuration(arg12, arg8, arg10);
			if(Afterlife_DoesAlreadyExist(arg8, arg12)) then 
				local incSource = nil;
				if(destGUID == UnitGUID("target")) then 
					incSource = "Target";
				elseif(destGUID == UnitGUID("focus")) then 
					incSource = "Focus"; 
				end; 
				duration = Afterlife_AddTrackedGUID(arg8, arg9, arg12, arg13, duration, GetTime(), ishostile, incSource, icon, Afterlife_CastingRaidIcon, arg12..arg8, arg5, arg10);
				if(Afterlife_SavedSettings[54]) then 
					AfterlifePrimaryGroup:RegisterBar(arg12..arg8, arg13.." ("..arg5..")", duration, duration, icon, nil); 
				end;
			end;
			
		elseif(arg2 == "SPELL_AURA_REMOVED" or arg2 == "SPELL_AURA_DISPELLED") then 
			Afterlife_GUIDBrokenFree(arg8, arg12);
			Afterlife_StartExpireTimer(arg8); 
			
		elseif(arg2 == "SPELL_AURA_BROKEN_SPELL") then 
			Afterlife_GUIDBrokenFree(arg8, arg12, arg5, arg16);
			Afterlife_StartExpireTimer(arg8);

		-- hmm SWING_DAMAGE no longer reports the spell broken by a swing damage, will need to look at this later  =)
		-- so it wont report who broke the target from a swing damage at present until i change this code so that I
		-- can determine if the spell is breakable (i.e banish etc is not)
		-- Michael 5/12/2011
	
		elseif(arg2 == "SWING_DAMAGE") then 
			if(Afterlife_SpellIsBreakable(spellID)) then 
--				Afterlife_GUIDBrokenFree(arg4, spellID, arg9, "Attack");
				Afterlife_StartExpireTimer(arg4);
			end;

		elseif(arg2 == "SPELL_MISSED") then 
			if(Afterlife_InterestedSpell(arg12) or arg12 == 355 or arg12 == 62124 or arg12 == 6795) then	-- a spell im interested in or a taunt/hand of reckoning/growl?
				if(arg9 == UnitName("player") and not(arg9 == UnitName("player"))) then 
					local msg = nil;
					if(arg15 == "IMMUNE" and Afterlife_SavedSettings[36]) then 
						if(Afterlife_SavedSettings[39]) then 
							PlaySoundFile(Afterlife_ImmuneSND); 
						end;
						if(Afterlife_SavedSettings[40]) then 
							Softrix_UIFlash("RED"); 
						end;
						msg = string.format(AFTERLIFE_SPELL_MISSED1, arg5, "IMMUNE", arg13); 
					elseif(arg15 == "RESIST" and Afterlife_SavedSettings[37]) then 
						msg = string.format(AFTERLIFE_SPELL_MISSED2, arg5, "RESISTED", arg13);
					elseif(arg15 == "EVADE" and Afterlife_SavedSettings[38]) then 
						msg = string.format(AFTERLIFE_SPELL_MISSED2, arg5, "EVADED", arg13);
					end;
					Afterlife_SetPartyStatus();
					if(not(Afterlife_ChatDestination==0) and msg) then 
						SendChatMessage(msg, Afterlife_ChatDestination); 
					end;
				end;
			end; 
		
		elseif(arg2 == "UNIT_DIED") then 
			Afterlife_RemoveDeadGUID(arg8);
			Afterlife_RemoveDeadDR(arg8);

		elseif(arg2 == "PARTY_KILL") then 
			Afterlife_RemoveDeadGUID(arg8);
			Afterlife_RemoveDeadDR(arg8);
			-- if this was my kill, run quakesounds.
			if(arg4 == UnitGUID("player")) then	Afterlife_QuakeSounds(arg8); end;
		end; 
		
	end; 
end;

--
--	Strip the server name from a player (for cross realm instances and battlegrounds)
--
function Afterlife_StripServer(name) 
	name = string.match(name, "[^-]*");
	return(name);
end;

--
--	Is this mob a threat to me?
--
function Afterlife_IsUnitHostile(mob_flags) 
	if (CombatLog_Object_IsA(mob_flags, COMBATLOG_FILTER_HOSTILE_PLAYERS) or  CombatLog_Object_IsA(mob_flags, COMBATLOG_FILTER_HOSTILE_UNITS)) then 
		return(true); 
	end;  
	return(false);  
end;

--
--	Is this mob a player?
--
function Afterlife_IsUnitPlayer(guid) 
	local guid = strsub(guid, 1 ,5);
	if(bit.band(guid, 0x00F) == 0) then 
		return(true); 
	end;
	return(false);
end;

--
--	Function to check my list of spells and return its duration.
--
function Afterlife_GetDuration(spellid, guid, flags) 
	for count,value in ipairs(Afterlife_SpellsSupported) do 
		if(value[1]==spellid) then 
			local _,_, icon,_,_,_,_,_,_ = GetSpellInfo(spellid);
			if(Afterlife_IsUnitPlayer(guid) and not(spellid == 33786)) then 
				return 10, icon, true, Afterlife_IsUnitHostile(flags), value[3], value[4];
			else 
				return value[2], icon, false, Afterlife_IsUnitHostile(flags), value[3], value[4]; 
			end;
		end;
	end;
	return(false);
end;

--
--	Function to check if a spell on a mob is breakable.. i.e. banish cant be broken
--
function Afterlife_SpellIsBreakable(spellid) 
	for count,value in ipairs(Afterlife_SpellsSupported) do 
		if(value[1]==spellid) then 
			return(true);
		end;
	end;
	return(false);
end;

--
--	Just a dirty function to check if a spell fired is something we are interested in.
--
function Afterlife_InterestedSpell(spellid) 
	for count,value in ipairs(Afterlife_SpellsSupported) do 
		if(value[1]==spellid) then 
			return(true);
		end;
	end;
	return(false);
end;

--
--	funtion to automatically change the reputation bar when I gain rep.
--
function Afterlife_AutoChangeRepBar(chatMessage) 
	local s,newFaction,factionName,isHeader,curRepBar;s,_,newFaction = string.find(chatMessage, AFTERLIFE_REPUTATION_PARSE_TXT);
	curRepBar = GetWatchedFactionInfo();
	if(s and newFaction ~= curRepBar) then 
		for i = 1, GetNumFactions() do 
			factionName,_,_,_,_,_,_,_,isHeader = GetFactionInfo(i);
			if(isHeader == nil and factionName == newFaction) then 
				SetWatchedFactionIndex(i);
				UIErrorsFrame:AddMessage(AFTERLIFE_AUTOREPBAR..newFaction..".", 0, 1.0, 0, 10) 
				DEFAULT_CHAT_FRAME:AddMessage(AFTERLIFE_AUTOREPBAR..newFaction..".", 0,1.0,0,10);
				return;
			end;
		end; 
	end; 
end;

--
--	Function to return the raid icon on my target
--
function Afterlife_ProcessRaidIcon() 
	local Target_RaidIcon = GetRaidTargetIndex("target");
	if(Target_RaidIcon) then 
		return(Afterlife_RaidMarks[Target_RaidIcon]);
	else 
		return(Afterlife_RaidMarks[9]); 
	end;
end;

function AfterlifeCloseCreditsFrame_OnClick() 
	AfterlifeCreditsFrame:Hide();
	Afterlife_Options:Show();
end;

--
--	3D frame OnUpdate - updates the time left on the mob
--
function Afterlife_3dOnUpdate() 
	if(Afterlife_SavedSettings[44]) then 
		local firetime, duration, caster = Afterlife_IsMobTracked(Afterlife_TargetGUID);
		if(caster) then 
			local timeleft = tonumber(duration)-(GetTime()-tonumber(firetime));
			timeleft = format("%2.1f",timeleft);
			if(tonumber(timeleft) <= 10.0) then 
				Afterlife_TargetsTime:SetTextColor(1.0,0,0,10); 
			end;
			if(tonumber(timeleft) <= 0) then 
				timeleft = 0; 
			end;
			Afterlife_TargetsTime:SetText(caster.." ("..timeleft..")");
		else 
			Afterlife_3DTargetFrame:Hide();
		end;
	end; 
end;

--
--	Add a mob to my list of tracked mobs.
--
function Afterlife_AddTrackedGUID(mobsid, mobsname, spellid, spellname, duration, firetime, ishostile, source, spellicon, raidicon, barid, caster, guid) 
	mobsname = Afterlife_StripServer(mobsname);
	local spelldur = duration;
	if(Afterlife_IsUnitPlayer(mobsid)) then 
		spelldur = Afterlife_TrackDR(mobsid, mobsname, spelldur, spellicon);
	end;
	Afterlife_RemoveExpiredGUID();
	Afterlife_DoesAlreadyExist(mobsid, spellid);
	tinsert(Afterlife_MonitoredMobs, {mobsid, mobsname, spellid, spellname, spelldur, firetime, ishostile, source, spellicon, raidicon, barid, caster});
	return(spelldur);
end;

--
--	Remove any expired from my list of tracked mobs
--
function Afterlife_RemoveExpiredGUID() 
	for count,value in ipairs(Afterlife_MonitoredMobs) do 
		local castTime = value[6];
		local timeNow = GetTime();
		local totaDur = timeNow - castTime;
		if(totaDur > value[5]) then 
			tremove(Afterlife_MonitoredMobs, count);
		end;
	end;
end;

--
--	Remove those who have died from my tracked mobs.
--
function Afterlife_RemoveDeadGUID(mobsid) 
	for count,value in ipairs(Afterlife_MonitoredMobs) do  
		if(value[1] == mobsid) then 
			AfterlifePrimaryGroup:UnregisterBar(value[11]) 
			tremove(Afterlife_MonitoredMobs, count);
		end;
	end;
end;

--
--	Check if this mob is already in my list of tracked mobs.
--
function Afterlife_DoesAlreadyExist(mobsid, spellid) 
	for count,value in ipairs(Afterlife_MonitoredMobs) do  
		if(value[1] == mobsid and value[3] == spellid) then 
			tremove(Afterlife_MonitoredMobs, count);
			return(true);
		end;
	end;
	return(false);
end;

--
--	Function to check if a selected guid is currently being tracked.
--
function Afterlife_IsMobTracked(mobsid)
	for count,value in ipairs(Afterlife_MonitoredMobs) do  
		if(value[1] == mobsid) then 
			return value[6], value[5], value[12];
		end;
	end;
	return(false);
end;

--
--	Function to show the popup, announce etc when mobs break.
--
function Afterlife_GUIDBrokenFree(mobsid, spellid, breaker, spellname) 
	for count,value in ipairs(Afterlife_MonitoredMobs) do  
		if(value[1] == mobsid and value[3] == spellid) then 
			Afterlife_TargetsTime:SetTextColor(1.0,0,0,10);
			Afterlife_TargetsTime:SetText("FREE");
			if(value[12] == UnitName("player")) then 
				Afterlife_SetPartyStatus();
				if(Afterlife_SavedSettings[35]) then 
					Afterlife_ShowBatmanPopup(); 
				end;
				if(Afterlife_SavedSettings[33]) then 
					PlaySoundFile(Afterlife_BreakSND); 
				end;
				if(Afterlife_SavedSettings[31]) then 
					if(breaker and not(Afterlife_IsBreakerIgnored(breaker))) then 
						local msg = string.format(AFTERLIFE_BREAK_PLAYER, value[4], value[10], value[2], breaker, spellname);
						if(not(Afterlife_ChatDestination == 0)) then 
							SendChatMessage(msg, Afterlife_ChatDestination); 
						end;
					elseif(not(breaker)) then 
						local msg = string.format(AFTERLIFE_BREAK_NORMAL, value[4], value[10], value[2]);
						if(not(Afterlife_ChatDestination == 0)) then 
							SendChatMessage(msg, Afterlife_ChatDestination); 
						end;
					end;
				end;
				if(Afterlife_SavedSettings[34]) then 
					Softrix_UIFlash("RED"); 
				end;
			end;
			AfterlifePrimaryGroup:UnregisterBar(value[11]) 
			tremove(Afterlife_MonitoredMobs, count);
		end;
	end;
end;

--
--	Clear all mobs being tracked and clear bars.
--
function Afterlife_ClearAllGUID() 
	Afterlife_MonitoredMobs = {};
	if (AfterlifePrimaryGroup) then AfterlifePrimaryGroup:UnregisterAllBars(); end;
	if (AfterlifeDiminishGroup) then AfterlifeDiminishGroup:UnregisterAllBars(); end;
end;

--
--	Function to show 15 second countdown when a mobs going to break.
--
local lastTime = 0;
function Afterlife_AnnounceCCExpire() 
	for count,value in ipairs(Afterlife_MonitoredMobs) do 
		if(value[12] == UnitName("player") and Afterlife_SavedSettings[41] or Afterlife_SavedSettings[42] and not(value[2] == value[12])) then 
			local timeleft = tonumber(value[5])-(GetTime()-tonumber(value[6]));
			timeleft = format("%2.1f",timeleft);
			if(tonumber(timeleft) == 15.0 and not(lastTime == timeleft)) then 
				lastTime = timeleft;Afterlife_SetPartyStatus();
				local msg;
				if(value[12] == UnitName("player")) then 
					msg = string.format(AFTERLIFE_SECONDS_TXT1, value[10], value[2], timeleft);
				else 
					msg = string.format(AFTERLIFE_SECONDS_TXT2, value[12], value[2], timeleft);
				end;
				if(not(Afterlife_ChatDestination==0)) then 
					SendChatMessage(msg, Afterlife_ChatDestination); 
				end;
				if(Afterlife_ChatDestination==0) then 
					DEFAULT_CHAT_FRAME:AddMessage("|cffff1010"..msg); 
				end;
			elseif(tonumber(timeleft) == 10.0 and not(lastTime == timeleft)) then 
				lastTime = timeleft;Afterlife_SetPartyStatus();
				local msg;
				if(value[12] == UnitName("player")) then 
					msg = string.format(AFTERLIFE_SECONDS_TXT1, value[10], value[2], timeleft);
				else 
					msg = string.format(AFTERLIFE_SECONDS_TXT2, value[12], value[2], timeleft);
				end;
				if(not(Afterlife_ChatDestination==0)) then 
					SendChatMessage(msg, Afterlife_ChatDestination); 
				end;
				if(Afterlife_ChatDestination==0) then 
					DEFAULT_CHAT_FRAME:AddMessage("|cffff1010"..msg); 
				end;
				if(Afterlife_SavedSettings[43] and value[12] == UnitName("player")) then 
					PlaySoundFile(Afterlife_10secSND); 
				end;
			elseif(tonumber(timeleft) == 5.0 and not(lastTime == timeleft)) then 
				lastTime = timeleft;Afterlife_SetPartyStatus();
				local msg;
				if(value[12] == UnitName("player")) then 
					msg = string.format(AFTERLIFE_SECONDS_TXT1, value[10], value[2], timeleft);
				else 
					msg = string.format(AFTERLIFE_SECONDS_TXT2, value[12], value[2], timeleft);
				end;
				if(not(Afterlife_ChatDestination==0)) then 
					SendChatMessage(msg, Afterlife_ChatDestination); 
				end;
				if(Afterlife_ChatDestination==0) then 
					DEFAULT_CHAT_FRAME:AddMessage("|cffff1010"..msg); 
				end;
			end;
		end;
	end;
end;

--
--	Add a diminish return to my list.
--
function Afterlife_TrackDR(mobs_id, mobs_name, duration, icon) 
	Afterlife_ClearExpiredDR();
	for count,value in ipairs(Afterlife_DRTracking) do 
		if(value[1] == mobs_id) then 
			local lastDur = value[4];
			lastDur = lastDur / 2; 
			value[4] = lastDur;
			return(lastDur);
		end;
	end;
	tinsert(Afterlife_DRTracking, {mobs_id, mobs_name, GetTime(), duration, icon});
	return(duration);
end;

--
--	Clear a expired diminish return.
--
function Afterlife_ClearExpiredDR()
	for count,value in ipairs(Afterlife_DRTracking) do 
		if(value[1]) then
			local fireTime = value[3];
			local timeNow = GetTime();
			local totaDur = timeNow - fireTime;
			if(totaDur > 18) then
				tremove(Afterlife_DRTracking, count);
			end;
		end;
	end;
end;

--
--	Start a diminish return countdown.
--
function Afterlife_StartExpireTimer(mobs_id)
	for count,value in ipairs(Afterlife_DRTracking) do 
		if(value[1]==mobs_id) then
			value[3] = GetTime();
 			AfterlifePrimaryGroup:SetInvert(false);
			if(Afterlife_SavedSettings[51]) then
				if(Afterlife_SavedSettings[54]) then
					AfterlifeDiminishGroup:RegisterBar(value[1], value[2].." (DR)", 18, 18, value[5], Afterlife_RedDR);
				end;
			end;
		end;
	end;
end;

--
--	Remove a dead diminish return
--
function Afterlife_RemoveDeadDR(mobs_id)
	for count,value in ipairs(Afterlife_DRTracking) do 
		if(value[1]==mobs_id) then
			AfterlifeDiminishGroup:UnregisterBar(mobs_id);
			tremove(Afterlife_DRTracking, count);
		end;
	end;
end;

--
--	Function to set the 3d target to my target and get the current duration.
--
function Afterlife_Set3dTarget(guid)
	if(guid and Afterlife_SavedSettings[44]) then
		local firetime, duration, caster = Afterlife_IsMobTracked(guid);
		if(caster) then
			local playername = UnitName("target");
			playername = Afterlife_StripServer(playername);
			Softrix_3DTargetModel:SetUnit("target");
			Afterlife_TargetsTime:SetTextColor(0,1.0,0,10);
			Afterlife_TargetsTime:SetText("");
			Afterlife_MobsName:SetText(UnitName("target"));
			Afterlife_3DTargetFrame:Show();
		end;
	else
		Afterlife_3DTargetFrame:Hide();
	end;
end;

--
--	Function to show the batman popup  =)
--
function Afterlife_ShowBatmanPopup()
	WarningGfx:SetTexture("Interface\\Addons\\Afterlife\\Graphics\\aiee.tga");
	Afterlife_TimeSinceLastUpdate = 0;
	Afterlife_Scale = .01;
	Afterlife_ScaleDirection = "up";
	Afterlife_Pause = 0;
	WarnFrame:Show();
	WarnFrame:SetScale(Afterlife_Scale);
end;

--
--	Batman controller code to zoom in and out.
--
function ACM_WarnFrame_OnUpdate(self, elapsed)
	if(Afterlife_MovingPopup == false) then
		Afterlife_TimeSinceLastUpdate = Afterlife_TimeSinceLastUpdate + elapsed;
		while(Afterlife_TimeSinceLastUpdate > Afterlife_UpdateInterval) do 
			if(Afterlife_ScaleDirection == "up") then
				Afterlife_Scale = Afterlife_Scale + Afterlife_ScaleInterval;
				WarnFrame:SetScale(Afterlife_Scale);
				if(Afterlife_Scale >= 1) then
					Afterlife_ScaleDirection = "pause";
				end;
			elseif(Afterlife_ScaleDirection == "down") then
				if(Afterlife_Scale <= .2) then
					WarnFrame:Hide();
					return;
				else
					Afterlife_Scale = Afterlife_Scale - Afterlife_ScaleInterval;
					WarnFrame:SetScale(Afterlife_Scale);
				end;
			elseif(Afterlife_ScaleDirection == "pause") then
				Afterlife_Pause = Afterlife_Pause + 1;
				if(Afterlife_Pause > Afterlife_GraphicPause) then
					Afterlife_ScaleDirection = "down";
				end;
			end;
			Afterlife_TimeSinceLastUpdate = Afterlife_TimeSinceLastUpdate - Afterlife_UpdateInterval;
		end;
	end;
end;

--
--	Flash UI code (Red or Green)
--
function Softrix_UIFlash(colour)
	if(colour == "GREEN") then
		Afterlife_FlashTexture:SetTexture(Afterlife_GreenFlashGFX);
	elseif(colour == "RED" or colour == nil) then
		Afterlife_FlashTexture:SetTexture(Afterlife_RedFlashGFX);
	end;
	Softrix_FlashFrame:SetAllPoints(UIParent);
	Softrix_FlashFrame:Show();
end;

function Softrix_OnFlash(self)
	self.elapsed = 0;
	self:SetAlpha(0);
end;

function Softrix_OnFlashUpdate(self, elapsed)
	elapsed = self.elapsed + elapsed;
	if(elapsed < 2.6) then
		local alpha = elapsed % 1.3;
		if(alpha < 0.15) then
			self:SetAlpha(alpha / 0.15);
		elseif(alpha < 0.9) then
			self:SetAlpha(1 - (alpha - 0.15) / 0.6);
		else
			self:SetAlpha(0);
		end;
	else
		self:Hide();
	end;
	self.elapsed = elapsed;
end;

--
--	Function to add a little spice into the pvp side of things - adds Unstoppable, First Blood etc
--	when killing players in pvp - both male and female are provided.
--
function Afterlife_QuakeSounds(guid)
	-- determine if we are male or female
	if(Afterlife_SavedSettings[46] == "Female") then Afterlife_SndOffset = 6; else Afterlife_SndOffset = 0;	end;
		if(Afterlife_IsUnitPlayer(guid) and Afterlife_SavedSettings[45] or Afterlife_SavedSettings[45] and Afterlife_SavedSettings[47]) then
			if (not Afterlife_killing_timer or (GetTime() - Afterlife_killing_timer >= 60)) then
				PlaySoundFile(Afterlife_QuakeSND[2+Afterlife_SndOffset]);
				Afterlife_killing_counter = 0;
			else
				Afterlife_killing_counter = Afterlife_killing_counter + 1;
				if (Afterlife_killing_counter == 1) then
					PlaySoundFile(Afterlife_QuakeSND[1+Afterlife_SndOffset]);
				elseif (Afterlife_killing_counter == 2) then
					PlaySoundFile(Afterlife_QuakeSND[4+Afterlife_SndOffset]);
				elseif (Afterlife_killing_counter == 3) then
					PlaySoundFile(Afterlife_QuakeSND[6+Afterlife_SndOffset]);
				elseif (Afterlife_killing_counter == 4) then
					PlaySoundFile(Afterlife_QuakeSND[5+Afterlife_SndOffset]);
				elseif (Afterlife_killing_counter > 4) then
					PlaySoundFile(Afterlife_QuakeSND[3+Afterlife_SndOffset]);
				end;
			end;
			Afterlife_killing_timer = GetTime();
		end;
end;


-- ************************************************************************************
-- ***  OPTIONS / CREDITS CODE
-- ************************************************************************************

function AfterlifeShowCredits()
	Afterlife_Options:Hide();
	AfterlifeCreditsFrame:Show();
end;

function TestBarsButton_OnClick()
	AfterlifePrimaryGroup:RegisterBar("TestBar1", "Entangling Roots (Test)", 30, 30, Afterlife_NEPlayer, nil);
	AfterlifePrimaryGroup:RegisterBar("TestBar2", "Shackle Undead (Test)", 45, 45, Afterlife_NEPlayer, nil);
	if(Afterlife_SavedSettings[51]) then
		AfterlifeDiminishGroup:RegisterBar("TestBar1", "Shackle Undead (Test)", 18, 18, Afterlife_NEPlayer, Afterlife_RedDR);
	end;
end;

function ToggleBarTitle_OnClick()
	if(Afterlife_SavedSettings[2]) then
		Afterlife_SavedSettings[2] = false;
	else
		Afterlife_SavedSettings[2] = true;
	end;
	AfterlifePrimaryGroup:SetAnchorVisible(Afterlife_SavedSettings[2]);
	if(Afterlife_SavedSettings[51]) then
		 AfterlifeDiminishGroup:SetAnchorVisible(Afterlife_SavedSettings[2]);
	 else
		AfterlifeDiminishGroup:SetAnchorVisible(false);
	end;
end;

function AfterlifeCloseOptions()
	Afterlife_Options:Hide();
end;

function Afterlife_InitOptions()
	if(Afterlife_SavedSettings[1]) then
		AfterlifeEnableAddonCheck:SetChecked(true);
	end;
	if(Afterlife_SavedSettings[30]) then
		AnnounceCCCheck:SetChecked(true);
	end;
	if(Afterlife_SavedSettings[31]) then
		AnnounceBreaksCheck:SetChecked(true);
	end;
	if(Afterlife_SavedSettings[32]) then
		AnnounceOthersCCSpells:SetChecked(true);
	end;
	if(Afterlife_SavedSettings[33]) then
		BreakSoundCheck:SetChecked(true);
	end;
	if(Afterlife_SavedSettings[34]) then
		BreakFlashGUICheck:SetChecked(true);
	end;
	if(Afterlife_SavedSettings[35]) then
		BreakShowPopupCheck:SetChecked(true);
	end;
	if(Afterlife_SavedSettings[41]) then
		AnnounceSecLeftCheck:SetChecked(true);
	end;
	if(Afterlife_SavedSettings[43]) then
		SecondsLeftSoundCheck:SetChecked(true);
	end;
	if(Afterlife_SavedSettings[42]) then
		AnnounceOthersTimeleftCheck:SetChecked(true);
	end;	
	-- unreal sounds added 5/12/2011 Mik.
	if(Afterlife_SavedSettings[45]) then
		UnrealSoundsCheckbox:SetChecked(true);
	end;
	if(Afterlife_SavedSettings[46] == "Male") then
		UnrealSoundsSexCheckbox:SetChecked(true);
	end;
	if(Afterlife_SavedSettings[47]) then
		UnrealSoundsNPCCheckbox:SetChecked(true);
	end;
	if(Afterlife_SavedSettings[50]) then
		AnnounceMyInterruptsCheck:SetChecked(true);
	end;
	if(Afterlife_SavedSettings[36]) then
		AnnounceImmuneCheck:SetChecked(true);
	end;
	if(Afterlife_SavedSettings[39]) then
		SoundImmuneCheck:SetChecked(true);
	end;
	if(Afterlife_SavedSettings[40]) then
		ImmuneFlashUICheck:SetChecked(true);
	end;
	if(Afterlife_SavedSettings[37]) then
		AnnounceResistCheck:SetChecked(true);
	end;
	if(Afterlife_SavedSettings[38]) then
		AnnounceSpellEvadesCheck:SetChecked(true);
	end;
	if(Afterlife_SavedSettings[44]) then
		Use3dModelCheck:SetChecked(true);
	end;
	if(Afterlife_SavedSettings[51]) then
		ShowDiminishReturnsCheck:SetChecked(true);
	end;
	if(Afterlife_SavedSettings[53]) then
		AutoReputationBarCheck:SetChecked(true);
	end;
	if(Afterlife_SavedSettings[5] == "UP") then
		BarDirectionCheckbox:SetChecked(true);
	end;
	if(Afterlife_SavedSettings[52]) then
		DisableAnnoucePVPCheck:SetChecked(true);
	end;
	if(Afterlife_SavedSettings[54]) then
		EnableTimerBarsCheck:SetChecked(true);
	end;
	if(Afterlife_SavedSettings[48]) then
		ClearTimersOnDeathCheck:SetChecked(true);
	end;
	AfterlifeHeightSlider:SetValue(Afterlife_SavedSettings[6]);
	AfterlifeHeightText:SetText(Afterlife_SavedSettings[6]);
	AfterlifeWidthSlider:SetValue(Afterlife_SavedSettings[7]);
	AfterlifeWidthText:SetText(Afterlife_SavedSettings[7]);
	AfterlifeFontSizeSlider:SetValue(Afterlife_SavedSettings[11]);
	AfterlifeFontSizeText:SetText(Afterlife_SavedSettings[11]);
	AfterlifeTextureSlider:SetValue(Afterlife_SavedSettings[8]);
	AfterlifeGroupTexture:SetTexture(Afterlife_Textures[Afterlife_SavedSettings[8]]);
end;

-- unreal sounds added 5/12/2011
function UnrealPvPSoundsClick_OnClick()
	local CheckboxEnabled = UnrealSoundsCheckbox:GetChecked();
	if(CheckboxEnabled == 1) then
		Afterlife_SavedSettings[45] = true;
	else
		Afterlife_SavedSettings[45] = false;
	end;
end;

function UnrealPvPSoundsSexClick_OnClick()
	local CheckboxEnabled = UnrealSoundsSexCheckbox:GetChecked();
	if(CheckboxEnabled == 1) then
		Afterlife_SavedSettings[46] = "Male";
	else
		Afterlife_SavedSettings[46] = "Female";
	end;
end;

function UnrealPvPSoundsNPC_OnClick()
	local CheckboxEnabled = UnrealSoundsNPCCheckbox:GetChecked();
	if(CheckboxEnabled == 1) then
		Afterlife_SavedSettings[47] = true;
	else
		Afterlife_SavedSettings[47] = false;
	end;
end;

function AnnounceMyInterruptsCheck_OnClick()
	local CheckboxEnabled = AnnounceMyInterruptsCheck:GetChecked();
	if(CheckboxEnabled == 1) then
		Afterlife_SavedSettings[50] = true;
	else
		Afterlife_SavedSettings[50] = false;
	end;
end;



function AfterlifeEnableAddonCheck_OnClick()
	local CheckboxEnabled = AfterlifeEnableAddonCheck:GetChecked();
	if(CheckboxEnabled == 1) then
		Afterlife_SavedSettings[1] = true;
	else
		Afterlife_SavedSettings[1] = false;
	end;
end;

function DisableAnnoucePVPCheck_OnClick()
	local CheckboxEnabled = DisableAnnoucePVPCheck:GetChecked();
	if(CheckboxEnabled == 1) then
		Afterlife_SavedSettings[52] = true;
		else
		Afterlife_SavedSettings[52] = false;
	end;
end;

function AnnounceCCCheck_OnClick()
	local CheckboxEnabled = AnnounceCCCheck:GetChecked();
	if(CheckboxEnabled == 1) then
		Afterlife_SavedSettings[30] = true;
	else
		Afterlife_SavedSettings[30] = false;
	end;
end;

function AnnounceBreaksCheck_OnClick()
	local CheckboxEnabled = AnnounceBreaksCheck:GetChecked();
	if(CheckboxEnabled == 1) then
		Afterlife_SavedSettings[31] = true;
	else
		Afterlife_SavedSettings[31] = false;
	end;
end;

function AnnounceMyPartyCCCheck_OnClick()
	local CheckboxEnabled = AnnounceOthersCCSpells:GetChecked();
	if(CheckboxEnabled == 1) then
		Afterlife_SavedSettings[32] = true;
	else
		Afterlife_SavedSettings[32] = false;
	end;
end;

function BreakSoundCheck_OnClick()
	local CheckboxEnabled = BreakSoundCheck:GetChecked();
	if(CheckboxEnabled == 1) then
		Afterlife_SavedSettings[33] = true;
	else
		Afterlife_SavedSettings[33] = false;
	end;
end;

function BreakFlashGUICheck_OnClick()
	local CheckboxEnabled = BreakFlashGUICheck:GetChecked();
	if(CheckboxEnabled == 1) then
		Afterlife_SavedSettings[34] = true;
	else
		Afterlife_SavedSettings[34] = false;
	end;
end;

function BreakShowPopupCheck_OnClick()
	local CheckboxEnabled = BreakShowPopupCheck:GetChecked();
	if(CheckboxEnabled == 1) then
		Afterlife_SavedSettings[35] = true;
	else
		Afterlife_SavedSettings[35] = false;
	end;
end;

function AnnounceSecLeftCheck_OnClick()
	local CheckboxEnabled = AnnounceSecLeftCheck:GetChecked();
	if(CheckboxEnabled == 1) then
		Afterlife_SavedSettings[41] = true;
	else
		Afterlife_SavedSettings[41] = false;
	end;
end;

function SecondsLeftSoundCheck_OnClick()
	local CheckboxEnabled = SecondsLeftSoundCheck:GetChecked();
	if(CheckboxEnabled == 1) then
		Afterlife_SavedSettings[43] = true;
	else
		Afterlife_SavedSettings[43] = false;
	end;
end;

function AnnounceOthersTimeleftCheck_OnClick()
	local CheckboxEnabled = AnnounceOthersTimeleftCheck:GetChecked();
	if(CheckboxEnabled == 1) then
		Afterlife_SavedSettings[42] = true;
	else
		Afterlife_SavedSettings[42] = false;
	end;
end;

function AnnounceImmuneCheck_OnClick()
	local CheckboxEnabled = AnnounceImmuneCheck:GetChecked();
	if(CheckboxEnabled == 1) then
		Afterlife_SavedSettings[36] = true;
	else
		Afterlife_SavedSettings[36] = false;
	end;
end;

function SoundImmuneCheck_OnClick()
	local CheckboxEnabled = SoundImmuneCheck:GetChecked();
	if(CheckboxEnabled == 1) then
		Afterlife_SavedSettings[39] = true;
	else
		Afterlife_SavedSettings[39] = false;
	end;
end;

function ImmuneFlashUICheck_OnClick()
	local CheckboxEnabled = ImmuneFlashUICheck:GetChecked();
	if(CheckboxEnabled == 1) then
		Afterlife_SavedSettings[40] = true;
	else
		Afterlife_SavedSettings[40] = false;
	end;
end;

function AnnounceResistCheck_OnClick()
	local CheckboxEnabled = AnnounceResistCheck:GetChecked();
	if(CheckboxEnabled == 1) then
		Afterlife_SavedSettings[37] = true;
	else
		Afterlife_SavedSettings[37] = false;
	end;
end;

function AnnounceSpellEvadesCheck_OnClick()
	local CheckboxEnabled = AnnounceSpellEvadesCheck:GetChecked();
	if(CheckboxEnabled == 1) then
		Afterlife_SavedSettings[38] = true;
	else
		Afterlife_SavedSettings[38] = false;
	end;
end;

function Use3dModelCheck_OnClick()
	local CheckboxEnabled = Use3dModelCheck:GetChecked();
	if(CheckboxEnabled == 1) then
		Afterlife_SavedSettings[44] = true;
	else
		Afterlife_SavedSettings[44] = false;
	end;
end;

function ShowDiminishReturnsCheck_OnClick()
	local CheckboxEnabled = ShowDiminishReturnsCheck:GetChecked();
	if(CheckboxEnabled == 1) then
		Afterlife_SavedSettings[51] = true;
		AfterlifeDiminishGroup:SetAnchorVisible(Afterlife_SavedSettings[2]);
	else
		AfterlifeDiminishGroup:SetAnchorVisible(false);
		Afterlife_SavedSettings[51] = false;
	end;
end;

function AutoReputationBarCheck_OnClick()
	local CheckboxEnabled = AutoReputationBarCheck:GetChecked();
	if(CheckboxEnabled == 1) then
		Afterlife_SavedSettings[53] = true;
	else
		Afterlife_SavedSettings[53] = false;
	end;
end;

function BarDirectionCheckbox_OnClick()
	local CheckboxEnabled = BarDirectionCheckbox:GetChecked();
	if(CheckboxEnabled == 1) then
		Afterlife_SavedSettings[5] = "UP";
		Afterlife_SavedSettings[14] = "UP";
	else
		Afterlife_SavedSettings[5] = "DOWN";
		Afterlife_SavedSettings[14] = "DOWN";
	end;
	AfterlifePrimaryGroup:SetBarGrowth(Afterlife_SavedSettings[5]);
	AfterlifeDiminishGroup:SetBarGrowth(Afterlife_SavedSettings[14]);
end;

function EnableTimerBarsCheck_OnClick()
	local CheckboxEnabled = EnableTimerBarsCheck:GetChecked();
	if(CheckboxEnabled == 1) then
		Afterlife_SavedSettings[54] = true;
	else
		Afterlife_SavedSettings[54] = false;
	end;
end;

function ClearTimersOnDeathCheck_OnClick()
	local CheckboxEnabled = ClearTimersOnDeathCheck:GetChecked();
	if(CheckboxEnabled == 1) then
		Afterlife_SavedSettings[48] = true;
	else
		Afterlife_SavedSettings[48] = false;
	end;
end;

function AfterlifeHeightSlider_OnValueChanged()
	if(AFTERLIFE_FULLYLOADED) then
		local value = AfterlifeHeightSlider:GetValue();
		AfterlifeHeightText:SetText(value);
		Afterlife_SavedSettings[6] = value;
		Afterlife_SavedSettings[15] = value;
		AfterlifePrimaryGroup:SetHeight(Afterlife_SavedSettings[6]);
		AfterlifeDiminishGroup:SetHeight(Afterlife_SavedSettings[15]);
	end;
end;

function AfterlifeWidthSlider_OnValueChanged()
	if(AFTERLIFE_FULLYLOADED) then
		local value = AfterlifeWidthSlider:GetValue();
		AfterlifeWidthText:SetText(value);
		Afterlife_SavedSettings[7] = value;
		Afterlife_SavedSettings[16] = value;
		AfterlifePrimaryGroup:SetWidth(Afterlife_SavedSettings[7]);
		AfterlifeDiminishGroup:SetWidth(Afterlife_SavedSettings[16]);
	end;
end;

function AfterlifeFontSizeSlider_OnValueChanged()
	if(AFTERLIFE_FULLYLOADED) then
		local value = AfterlifeFontSizeSlider:GetValue();
		AfterlifeFontSizeText:SetText(value);
		Afterlife_SavedSettings[11] = value;
		Afterlife_SavedSettings[20] = value;
		AfterlifePrimaryGroup:SetGroupFontSize(Afterlife_SavedSettings[11]);
		AfterlifeDiminishGroup:SetGroupFontSize(Afterlife_SavedSettings[20]);
	end;
end;

function AfterlifeTextureSlider_OnValueChanged()
	if(AFTERLIFE_FULLYLOADED) then
		local value = AfterlifeTextureSlider:GetValue();
		Afterlife_SavedSettings[8] = value;
		Afterlife_SavedSettings[17] = value;
		AfterlifePrimaryGroup:SetTexture(Afterlife_Textures[value]);
		AfterlifeDiminishGroup:SetTexture(Afterlife_Textures[value]);
		AfterlifeGroupTexture:SetTexture(Afterlife_Textures[value]);
	end;
end;

function Afterlife_AddIgnoredPlayer(playerName)
	for count,value in ipairs(Afterlife_IgnoredPlyrBreaks) do  
		if(value[1] == playerName) then
			DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife : |cffffffff["..playerName.."] is already being ignored.");
			return(false);
		end;
	end;
	tinsert(Afterlife_IgnoredPlyrBreaks, {playerName});
	DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife : |cffffffffAdded ["..playerName.."] to the ignore list.");
	return(true);
end;

function Afterlife_RemoveIgnoredPlayer(playerName)
	for count,value in ipairs(Afterlife_IgnoredPlyrBreaks) do  
		if(value[1] == playerName) then
			DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife : |cffffffff["..playerName.."] has been deleted from the ignore list.");
			tremove(Afterlife_IgnoredPlyrBreaks, count);
			return(true);
		end;
	end;
	DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffAfterlife : |cffffffff["..playerName.."] is not currently ignored.");
	return(false);
end;

function Afterlife_ShowAllIgnoredPlayers()
	for count,value in ipairs(Afterlife_IgnoredPlyrBreaks) do  
		if(value[1]) then
			DEFAULT_CHAT_FRAME:AddMessage("|cff00e0ffIgnoring |cffffffff["..value[1].."].");
		end;
	end;
end;

function Afterlife_IsBreakerIgnored(playerName)
	for count,value in ipairs(Afterlife_IgnoredPlyrBreaks) do  
		if(value[1] == playerName) then
			return(true);
		end;
	end;
	return(false);
end;
