﻿

--[[


	$project:		Afterlife Crowd Control
	$copyright:		Michael Boyle (www.softrix.co.uk).
							
	$credits:		Created by Michael Boyle.

					This addon uses a modified version of the GTB
					bar library by Shadowed. For the purpose of 
					these credits the original bar library can be
					downloaded from:
							
					http://www.wowinterface.com/downloads/info10204-GTB-1.0.html
					
					Special thanks to Arbixal, pakal1 on curse.com for their development
					support while i was absent.
		
]]--


--
--	Setup locals
--
function Afterlife_SetLocalisation()
	
	-- wheres this client then?
	local client_area = GetLocale();		

	-- English/US
	if(client_area == "enUS") then 

		-- group titles
		PRIMARY_GROUP_TITLE =				"Crowd Controls";
		DIMINSH_RETURNS_TITLE =				"Diminish Returns";
		-- Announces.
		AFTERLIFE_APPLIED_SPELL =			"[%s] has been applied to [%s%s].";					-- [Shackle Undead] has been appled to [Skeletal Warrior].
		AFTERLIFE_PARTY_APPLIED_SPELL =		"[%s] has applied [%s] to [%s%s]";					-- [Shackle Undead] has been appled to [Skeletal Warrior].
		AFTERLIFE_BREAK_NORMAL =			"[%s] has broken on [%s%s].";						-- [Polymorph] has broken on [Afterlife].
		AFTERLIFE_BREAK_PLAYER =			"[%s] was broken on [%s%s] by %s's %s.";			-- [Polymorph was broken on [Afterlife] by Shedney.
		AFTERLIFE_SECONDS_TXT1 =			"[%s%s] breaks free in %d seconds.";				-- [Afterlife] breaks free in 10 seconds.
		AFTERLIFE_SECONDS_TXT2 =			"%s's [%s] breaks free in %d seconds.";				-- Silverblosse's [Skeletal Warrior] breaks free in 10 seconds.
		AFTERLIFE_SPELL_MISSED1 =			"[%s] is %s to [%s].";								-- [Afterlife] is IMMUNE to [Polymorph].
		AFTERLIFE_SPELL_MISSED2 =			"[%s] has %s my [%s].";								-- [Afterlife] has RESISTED my [Polymorph].
		AFTERLIFE_SPELL_INTERRUPTED =		"[%s] was interrupted by %s's [%s].";				-- [Polymorph] was interrupted by Quality's [Rebuke].

		-- Auto Reputation bar.
		AFTERLIFE_REPUTATION_PARSE_TXT =	"Reputation with (.+) increased by (%d+).";
		AFTERLIFE_AUTOREPBAR =				"|cff00e0ffAfterlife : |cffffffffReputation bar changed to ";	

	-- France
	elseif(client_area == "frFR") then 

		-- group titles
		PRIMARY_GROUP_TITLE =				"Crowd Controls";
		DIMINSH_RETURNS_TITLE =				"Diminish Returns";
		-- Announces.
		AFTERLIFE_APPLIED_SPELL =			"[%s] has been applied to [%s%s].";					-- [Shackle Undead] has been appled to [Skeletal Warrior].
		AFTERLIFE_PARTY_APPLIED_SPELL =		"[%s] has applied [%s] to [%s%s]";					-- [Shackle Undead] has been appled to [Skeletal Warrior].
		AFTERLIFE_BREAK_NORMAL =			"[%s] has broken on [%s%s].";						-- [Polymorph] has broken on [Afterlife].
		AFTERLIFE_BREAK_PLAYER =			"[%s] was broken on [%s%s] by %s's %s.";			-- [Polymorph was broken on [Afterlife] by Shedney.
		AFTERLIFE_SECONDS_TXT1 =			"[%s%s] breaks free in %d seconds.";				-- [Afterlife] breaks free in 10 seconds.
		AFTERLIFE_SECONDS_TXT2 =			"%s's [%s] breaks free in %d seconds.";				-- Silverblosse's [Skeletal Warrior] breaks free in 10 seconds.
		AFTERLIFE_SPELL_MISSED1 =			"[%s] is %s to [%s].";								-- [Afterlife] is IMMUNE to [Polymorph].
		AFTERLIFE_SPELL_MISSED2 =			"[%s] has %s my [%s].";								-- [Afterlife] has RESISTED my [Polymorph].
		AFTERLIFE_SPELL_INTERRUPTED =		"[%s] was interrupted by %s's [%s].";				-- [Polymorph] was interrupted by Quality's [Rebuke].

		-- Auto Reputation bar.
		AFTERLIFE_REPUTATION_PARSE_TXT =	"Reputation with (.+) increased by (%d+).";
		AFTERLIFE_AUTOREPBAR =				"|cff00e0ffAfterlife : |cffffffffReputation bar changed to ";	

	-- German
	elseif(client_area == "deDE") then 

		-- group titles
		PRIMARY_GROUP_TITLE =				"Crowd Controls";
		DIMINSH_RETURNS_TITLE =				"Diminish Returns";
		-- Announces.
		AFTERLIFE_APPLIED_SPELL =			"[%s] has been applied to [%s%s].";					-- [Shackle Undead] has been appled to [Skeletal Warrior].
		AFTERLIFE_PARTY_APPLIED_SPELL =		"[%s] has applied [%s] to [%s%s]";					-- [Shackle Undead] has been appled to [Skeletal Warrior].
		AFTERLIFE_BREAK_NORMAL =			"[%s] has broken on [%s%s].";						-- [Polymorph] has broken on [Afterlife].
		AFTERLIFE_BREAK_PLAYER =			"[%s] was broken on [%s%s] by %s's %s.";			-- [Polymorph was broken on [Afterlife] by Shedney.
		AFTERLIFE_SECONDS_TXT1 =			"[%s%s] breaks free in %d seconds.";				-- [Afterlife] breaks free in 10 seconds.
		AFTERLIFE_SECONDS_TXT2 =			"%s's [%s] breaks free in %d seconds.";				-- Silverblosse's [Skeletal Warrior] breaks free in 10 seconds.
		AFTERLIFE_SPELL_MISSED1 =			"[%s] is %s to [%s].";								-- [Afterlife] is IMMUNE to [Polymorph].
		AFTERLIFE_SPELL_MISSED2 =			"[%s] has %s my [%s].";								-- [Afterlife] has RESISTED my [Polymorph].
		AFTERLIFE_SPELL_INTERRUPTED =		"[%s] was interrupted by %s's [%s].";				-- [Polymorph] was interrupted by Quality's [Rebuke].

		-- Auto Reputation bar.
		AFTERLIFE_REPUTATION_PARSE_TXT =	"Euer Ruf bei der Fraktion '(.+)' hat sich um (%d+) verbessert.";
		AFTERLIFE_AUTOREPBAR =				"|cff00e0ffNatur : |cffffffffRufleiste gewechselt zu ";	

	-- Korean
	elseif(client_area == "koKR") then 

		-- group titles
		PRIMARY_GROUP_TITLE =				"Crowd Controls";
		DIMINSH_RETURNS_TITLE =				"Diminish Returns";
		-- Announces.
		AFTERLIFE_APPLIED_SPELL =			"[%s] has been applied to [%s%s].";					-- [Shackle Undead] has been appled to [Skeletal Warrior].
		AFTERLIFE_PARTY_APPLIED_SPELL =		"[%s] has applied [%s] to [%s%s]";					-- [Shackle Undead] has been appled to [Skeletal Warrior].
		AFTERLIFE_BREAK_NORMAL =			"[%s] has broken on [%s%s].";						-- [Polymorph] has broken on [Afterlife].
		AFTERLIFE_BREAK_PLAYER =			"[%s] was broken on [%s%s] by %s's %s.";			-- [Polymorph was broken on [Afterlife] by Shedney.
		AFTERLIFE_SECONDS_TXT1 =			"[%s%s] breaks free in %d seconds.";				-- [Afterlife] breaks free in 10 seconds.
		AFTERLIFE_SECONDS_TXT2 =			"%s's [%s] breaks free in %d seconds.";				-- Silverblosse's [Skeletal Warrior] breaks free in 10 seconds.
		AFTERLIFE_SPELL_MISSED1 =			"[%s] is %s to [%s].";								-- [Afterlife] is IMMUNE to [Polymorph].
		AFTERLIFE_SPELL_MISSED2 =			"[%s] has %s my [%s].";								-- [Afterlife] has RESISTED my [Polymorph].
		AFTERLIFE_SPELL_INTERRUPTED =		"[%s] was interrupted by %s's [%s].";				-- [Polymorph] was interrupted by Quality's [Rebuke].
		
		-- Auto Reputation bar.
		AFTERLIFE_REPUTATION_PARSE_TXT =	"Reputation with (.+) increased by (%d+).";
		AFTERLIFE_AUTOREPBAR =				"|cff00e0ffAfterlife : |cffffffffReputation bar changed to ";	

	-- Chinese (simplified)
	elseif(client_area == "zhCN") then 

		-- group titles
		PRIMARY_GROUP_TITLE =				"Crowd Controls";
		DIMINSH_RETURNS_TITLE =				"Diminish Returns";
		-- Announces.
		AFTERLIFE_APPLIED_SPELL =			"[%s] has been applied to [%s%s].";					-- [Shackle Undead] has been appled to [Skeletal Warrior].
		AFTERLIFE_PARTY_APPLIED_SPELL =		"[%s] has applied [%s] to [%s%s]";					-- [Shackle Undead] has been appled to [Skeletal Warrior].
		AFTERLIFE_BREAK_NORMAL =			"[%s] has broken on [%s%s].";						-- [Polymorph] has broken on [Afterlife].
		AFTERLIFE_BREAK_PLAYER =			"[%s] was broken on [%s%s] by %s's %s.";			-- [Polymorph was broken on [Afterlife] by Shedney.
		AFTERLIFE_SECONDS_TXT1 =			"[%s%s] breaks free in %d seconds.";				-- [Afterlife] breaks free in 10 seconds.
		AFTERLIFE_SECONDS_TXT2 =			"%s's [%s] breaks free in %d seconds.";				-- Silverblosse's [Skeletal Warrior] breaks free in 10 seconds.
		AFTERLIFE_SPELL_MISSED1 =			"[%s] is %s to [%s].";								-- [Afterlife] is IMMUNE to [Polymorph].
		AFTERLIFE_SPELL_MISSED2 =			"[%s] has %s my [%s].";								-- [Afterlife] has RESISTED my [Polymorph].
		AFTERLIFE_SPELL_INTERRUPTED =		"[%s] was interrupted by %s's [%s].";				-- [Polymorph] was interrupted by Quality's [Rebuke].
		
		-- Auto Reputation bar.
		AFTERLIFE_REPUTATION_PARSE_TXT =	"Reputation with (.+) increased by (%d+).";
		AFTERLIFE_AUTOREPBAR =				"|cff00e0ffAfterlife : |cffffffffReputation bar changed to ";	

	-- Chinese (traditional)
	elseif(client_area == "zhTW") then 

		-- group titles
		PRIMARY_GROUP_TITLE =				"Crowd Controls";
		DIMINSH_RETURNS_TITLE =				"Diminish Returns";
		-- Announces.
		AFTERLIFE_APPLIED_SPELL =			"[%s] 已經施放到 [%s%s].";							-- [Shackle Undead] has been appled to [Skeletal Warrior].
		AFTERLIFE_PARTY_APPLIED_SPELL =		"[%s] has applied [%s] to [%s%s]";					-- [Shackle Undead] has been appled to [Skeletal Warrior].
		AFTERLIFE_BREAK_NORMAL =			"[%s] 在 [%s%s] 身上已經失效了.";						-- [Polymorph] has broken on [Afterlife].
		AFTERLIFE_BREAK_PLAYER =			"[%s] 在 [%s%s] 的法術因為 %s的 %s 失效了。";			-- [Polymorph] was broken on [Afterlife] by Shedney.
		AFTERLIFE_SECONDS_TXT1 =			"[%s%s] 在 %d 秒後脫離控場。";						-- [Afterlife] breaks free in 10 seconds.
		AFTERLIFE_SECONDS_TXT2 =			"%s的 [%s] 將在 %d 秒後消失。";						-- Silverblosse's [Skeletal Warrior] breaks free in 10 seconds.
		AFTERLIFE_SPELL_MISSED1 =			"[%s] %s [%s]。";									-- [Afterlife] is IMMUNE to [Polymorph].
		AFTERLIFE_SPELL_MISSED2 =			"[%s] %s 我的 [%s]。";								-- [Afterlife] has RESISTED my [Polymorph].
		AFTERLIFE_SPELL_INTERRUPTED =		"[%s] was interrupted by %s's [%s].";				-- [Polymorph] was interrupted by Quality's [Rebuke].

		-- Auto Reputation bar.
		AFTERLIFE_REPUTATION_PARSE_TXT =	"Reputation with (.+) increased by (%d+).";
		AFTERLIFE_AUTOREPBAR =				"|cff00e0ffAfterlife : |cffffffffReputation bar changed to ";

	-- Russian
	elseif(client_area == "ruRU") then 

		-- group titles
		PRIMARY_GROUP_TITLE =				"Crowd Controls";
		DIMINSH_RETURNS_TITLE =				"Diminish Returns";
		-- Announces.
		AFTERLIFE_APPLIED_SPELL =			"[%s] has been applied to [%s%s].";					-- [Shackle Undead] has been appled to [Skeletal Warrior].
		AFTERLIFE_PARTY_APPLIED_SPELL =		"[%s] has applied [%s] to [%s%s]";					-- [Shackle Undead] has been appled to [Skeletal Warrior].
		AFTERLIFE_BREAK_NORMAL =			"[%s] has broken on [%s%s].";						-- [Polymorph] has broken on [Afterlife].
		AFTERLIFE_BREAK_PLAYER =			"[%s] was broken on [%s%s] by %ss %s.";				-- [Polymorph was broken on [Afterlife] by Shedney.
		AFTERLIFE_SECONDS_TXT1 =			"[%s%s] breaks free in %d seconds.";				-- [Afterlife] breaks free in 10 seconds.
		AFTERLIFE_SECONDS_TXT2 =			"%s's [%s] breaks free in %d seconds.";				-- Silverblosse's [Skeletal Warrior] breaks free in 10 seconds.
		AFTERLIFE_SPELL_MISSED1 =			"[%s] is %s to [%s].";								-- [Afterlife] is IMMUNE to [Polymorph].
		AFTERLIFE_SPELL_MISSED2 =			"[%s] has %s my [%s].";								-- [Afterlife] has RESISTED my [Polymorph].
		AFTERLIFE_SPELL_INTERRUPTED =		"[%s] was interrupted by %s's [%s].";				-- [Polymorph] was interrupted by Quality's [Rebuke].

		-- Auto Reputation bar.
		AFTERLIFE_REPUTATION_PARSE_TXT =	"Reputation with (.+) increased by (%d+).";
		AFTERLIFE_AUTOREPBAR =				"|cff00e0ffAfterlife : |cffffffffReputation bar changed to ";	

	-- Spanish (Spain)
	elseif(client_area == "esES") then 

		-- group titles
		PRIMARY_GROUP_TITLE =				"Crowd Controls";
		DIMINSH_RETURNS_TITLE =				"Diminish Returns";
		-- Announces.
		AFTERLIFE_APPLIED_SPELL =			"[%s] has been applied to [%s%s].";					-- [Shackle Undead] has been appled to [Skeletal Warrior].
		AFTERLIFE_PARTY_APPLIED_SPELL =		"[%s] has applied [%s] to [%s%s]";					-- [Shackle Undead] has been appled to [Skeletal Warrior].
		AFTERLIFE_BREAK_NORMAL =			"[%s] has broken on [%s%s].";						-- [Polymorph] has broken on [Afterlife].
		AFTERLIFE_BREAK_PLAYER =			"[%s] was broken on [%s%s] by %s's %s.";			-- [Polymorph was broken on [Afterlife] by Shedney.
		AFTERLIFE_SECONDS_TXT1 =			"[%s%s] breaks free in %d seconds.";				-- [Afterlife] breaks free in 10 seconds.
		AFTERLIFE_SECONDS_TXT2 =			"%s's [%s] breaks free in %d seconds.";				-- Silverblosse's [Skeletal Warrior] breaks free in 10 seconds.
		AFTERLIFE_SPELL_MISSED1 =			"[%s] is %s to [%s].";								-- [Afterlife] is IMMUNE to [Polymorph].
		AFTERLIFE_SPELL_MISSED2 =			"[%s] has %s my [%s].";								-- [Afterlife] has RESISTED my [Polymorph].
		AFTERLIFE_SPELL_INTERRUPTED =		"[%s] was interrupted by %s's [%s].";				-- [Polymorph] was interrupted by Quality's [Rebuke].

		-- Auto Reputation bar.
		AFTERLIFE_REPUTATION_PARSE_TXT =	"Reputation with (.+) increased by (%d+).";
		AFTERLIFE_AUTOREPBAR =				"|cff00e0ffAfterlife : |cffffffffReputation bar changed to ";	

	-- Mexico
	elseif(client_area == "esMX") then 

		-- group titles
		PRIMARY_GROUP_TITLE =				"Crowd Controls";
		DIMINSH_RETURNS_TITLE =				"Diminish Returns";
		-- Announces.
		AFTERLIFE_APPLIED_SPELL =			"[%s] has been applied to [%s%s].";					-- [Shackle Undead] has been appled to [Skeletal Warrior].
		AFTERLIFE_PARTY_APPLIED_SPELL =		"[%s] has applied [%s] to [%s%s]";					-- [Shackle Undead] has been appled to [Skeletal Warrior].
		AFTERLIFE_BREAK_NORMAL =			"[%s] has broken on [%s%s].";						-- [Polymorph] has broken on [Afterlife].
		AFTERLIFE_BREAK_PLAYER =			"[%s] was broken on [%s%s] by %s's %s.";			-- [Polymorph was broken on [Afterlife] by Shedney.
		AFTERLIFE_SECONDS_TXT1 =			"[%s%s] breaks free in %d seconds.";				-- [Afterlife] breaks free in 10 seconds.
		AFTERLIFE_SECONDS_TXT2 =			"%s's [%s] breaks free in %d seconds.";				-- Silverblosse's [Skeletal Warrior] breaks free in 10 seconds.
		AFTERLIFE_SPELL_MISSED1 =			"[%s] is %s to [%s].";								-- [Afterlife] is IMMUNE to [Polymorph].
		AFTERLIFE_SPELL_MISSED2 =			"[%s] has %s my [%s].";								-- [Afterlife] has RESISTED my [Polymorph].
		AFTERLIFE_SPELL_INTERRUPTED =		"[%s] was interrupted by %s's [%s].";				-- [Polymorph] was interrupted by Quality's [Rebuke].

		-- Auto Reputation bar.
		AFTERLIFE_REPUTATION_PARSE_TXT =	"Reputation with (.+) increased by (%d+).";
		AFTERLIFE_AUTOREPBAR =				"|cff00e0ffAfterlife : |cffffffffReputation bar changed to ";	

	end;
	
end;